<template>
  <div>
    <div v-show="isEnabled" style="width: 100%; height: 350px">
      <v-row style="width: 100%; height: 100%">
        <v-col cols="11">
          <div id="realtime_plot" style="width: 100%; height: 100%"></div>
        </v-col>
        <v-col cols="1" align="center">
          <ChartButton
            v-for="(dataset, i) in datasets"
            :key="'dataset.label' + i"
            :color.sync="datasets[i].color"
            :name="dataset.label"
            :index="i"
            @toggled="changeVisibility"
            @update="updateLabels"
          />
        </v-col>
      </v-row>
    </div>

    <v-row class="placeholder" v-show="!isEnabled" align="center">
      <v-col justify="center" align="center">
        <p class="display-3">Chart disabled</p>
        <p class="headline">
          To display the live chart, please enable it in the
          <v-icon>mdi-tune</v-icon>Settings
        </p>
        <v-btn @click="openSettings">Open settings</v-btn>
      </v-col>
    </v-row>
  </div>
</template>

<script>
import ChartButton from "./Chart/ChartButton";

import Dygraph from "dygraphs";
import { EventBus } from "@/plugins/bus.js";

export default {
  name: "Chart",
  components: {
    ChartButton,
  },
  data() {
    return {
      plot: null,
      data: [],
      index: 0,
      event_emitted: false,
    };
  },
  computed: {
    isEnabled() {
      return this.$store.getters["settings/chart"];
    },
    datasets: {
      get() {
        return this.$store.getters["logs/datasets"];
      },
    },
    colors: {
      get() {
        return this.$store.getters["logs/colors"];
      },
    },
    labels() {
      return ["Time"].concat(this.$store.getters["logs/labels"]);
    },
  },
  methods: {
    openSettings() {
      this.$store.dispatch("drawer/showSettings", true);
    },

    initPlot() {
      this.plot = new Dygraph("realtime_plot", [], {
        labels: this.labels,
        colors: this.colors,
        strokeWidth: 2.0,
      });
      // show the plot
      setTimeout(() => {
        this.plot.resize();
      }, 100);
    },

    addData(values) {
      let result = values.map(function (x) {
        return Number(x);
      });
      this.data.push(result);
    },

    addDataLists(values) {
      this.data.push(...values);
    },

    reset() {
      this.plot.destroy();
      this.data = [];
      this.index = 0;
      this.event_emitted = false;
      this.initPlot();
    },

    trim(value) {
      this.data.splice(0, Math.max(0, this.data.length - value));
    },

    updateLabels() {
      this.plot.updateOptions({
        labels: this.labels,
        colors: this.colors,
      });
    },

    updateChart() {
      this.plot.updateOptions({ file: this.data });
    },

    changeVisibility(index, value) {
      this.plot.setVisibility(index, value);
    },
  },
  mounted() {
    this.initPlot();

    EventBus.$on("resetWidgets", this.reset);

    this.$socket.on("log", (data) => {
      if (data.logs.length == 0) return;

      // Add missing datasets automatically
      while (this.labels.length < data.logs[0].length) {
        this.$store.dispatch("logs/addDataset");
        this.updateLabels();
      }

      // Data object to store the visualized log
      let average_log = new Array(data.logs[0].length).fill(0);

      data.logs.forEach((log) => {
        log.forEach((value, i) => {
          average_log[i] += value;
        });
      });

      for (let i = 0; i < average_log.length; i++)
        average_log[i] = (average_log[i] / data.logs.length).toFixed(4);

      // Push the new values
      this.$store.dispatch("logs/displayLog", average_log);

      let i, j, temparray, chunk = 10;
      for (i = 0, j = data.logs.length; i<j; i+=chunk) {
          temparray = data.logs.slice(i,i+chunk);

          let average = new Array(temparray[0].length).fill(0);

          temparray.forEach((log) => {
            log.forEach((value, i) => {
              average[i] += value;
            });
          });

          for (let k = 0; k < average.length; k++)
            average[k] = (average[k] / temparray.length).toFixed(4);
          this.addData(average);
      }

      // Trim the buffer
      if (!this.$store.getters["settings/infinite_buffer"]) {
        this.trim(1000);
      }

      // Manually update the chart
      if (this.$store.getters["settings/chart"]) {
        this.updateChart();
      }
      if (!this.event_emitted) {
        this.event_emitted = !this.event_emitted;
        EventBus.$emit("logStarted");
      }
    });
  },
};
</script>

<style scoped>
.placeholder {
  height: 400px;
}
</style>